﻿# PomPi - Pompous Piping (Pompás ('Nagyképű') Csövező) :-))
  
# Copyright 2016, Dezmo
# /Without any obligation/

# This software is provided as a good (or bad) example of using the 
# Ruby interface (including html and javascript) in SketchUp.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY WARRANTIES.
# I am not responsible for any damages caused, use it on your risk.
# However if you like, feel free to buy me a cup of coffee ...

# Initializer for PomPi (Pompous Piping).

require 'sketchup.rb'
require 'extensions.rb'

extension_name="PomPi 2016 by Dezmo"

ext = SketchupExtension.new(extension_name, "Dezmo_pompi2016/Dezmo_pompi2016_main.rb")

ext.description = 'With help of the html UI, you can create infinite variety of pipe element. (pipe, bend, T, reducer,...). Dimensions are from CSV file, or by manual entering. Visit http://sketchucation.com/forums, you may get some help.'
ext.version = "2016 Beta"
ext.creator = "Dezmo (dezmo at freemail dot hu)"
ext.copyright = "2016, Dezmo"

# Register the extension with Sketchup.
Sketchup.register_extension ext, true