#PomPi 2016 Copyright 2016, Dezmo
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#---------------------------------------------------------------------------- 

module Dezmo_pompi2016
####################################################################################	
#	Creating straight pipe 
	def self.pompi_pipe(p2,vector,length,trans,angletw)
	mod = Sketchup.active_model # Open model
	ent = mod.entities # All entities in model
	sel = mod.selection # Current selection
	definitions = mod.definitions # all component definitions
	$this_was_the_pipeline_csodarab_what_we_need_to_rotate_with_bend=nil
	
	mod.start_operation("PomPi: Create pipe.",true) if @kind!="pipe_auto"
	angletwtext =""
	angletwtext =" TW"+(((1000.0*angletw.radians).round)/1000.0).to_s if (angletw and (angletw.abs>0.0017))
	
	exsist = false
	definitions.each {|e| 
		if (e.name==@cnam1+" "+length.to_s+" "+@cdes1+angletwtext and @kind!="pipe") or (e.name==@cnam1+" ~ "+length.to_s+" "+@cdes1+angletwtext and @kind=="pipe")
		exsist = true
		#puts "We have it already!" #debug
		@pipep = e
	#Sketchup.active_model.select_tool Dezmo_pompi2016::Place_pompi_component.new e, @kind					
		end #if
	}	
	
	if exsist==false	
		vb = Geom::Vector3d.new 0,0,1 # vector for base circle
		c_ba = Geom::Point3d.new 0,0,0 #center of base circle
		c_ba1 = Geom::Point3d.new 0,0,length # this is a center line endpoint (start is the origin)
		
		@pipep = mod.definitions.add "Pipe_ "
		entities = @pipep.entities
		@pipep.name = @cnam1+" "+length.to_s+" "+@cdes1+angletwtext
		@pipep.name = @cnam1+" ~ "+length.to_s+" "+@cdes1+angletwtext if @kind=="pipe"
			@pipep.description =  "PomPi " + Time.now.to_s
		#puts "l", length,length.to_s  # debug         
	@pipep.behavior.is2d         = true
	@pipep.behavior.cuts_opening = true
		
		# Create a base circles according circle/polygon
		if @ngo == "1"
			b_base_o = @pipep.entities.add_circle(c_ba, vb, @ro1, @spi)
			b_base_i = @pipep.entities.add_circle(c_ba, vb, @ri1, @spi) if @ri1 != 0
			else 
			b_base_o = @pipep.entities.add_ngon(c_ba, vb, @ro1, @spi)
			b_base_i = @pipep.entities.add_ngon(c_ba, vb, @ri1, @spi) if @ri1 != 0
		end #if
		
		# Create face whit hole or not
		face_base_i = @pipep.entities.add_face(b_base_i) if @ri1 != 0 # first the inner, if we have
		face_base_o = @pipep.entities.add_face(b_base_o) # than the outer face 
		face_base_i.erase!  if @ri1 != 0 # now we can remove the hole
		#face_base_o.reverse!
		
		# Rotate the cross-section:
		#rpi=@rpi if @spi%2<1   #if @spi even
		#rpi=(@rpi-(Math::PI/@spi)) if @spi%2>0   #if @spi odd


		trpi = Geom::Transformation.rotation c_ba, vb, @rpi # transform 
		entities.transform_entities(trpi, face_base_o) 		
		
		# Extrude base face by follow me method, (pushpull used...)
		path = @pipep.entities.add_line(c_ba, c_ba1)
		#face_base_o.followme(path)
		face_base_o.pushpull(-length, true)
		face_base_o.reverse!	
		######################################	twist one end
		trpi_tw = Geom::Transformation.rotation c_ba, vb, angletw  if (@kind=="pipe_auto" and angletw) # transform
		entities.transform_entities(trpi_tw, face_base_o) if (@kind=="pipe_auto" and angletw)

		######################################
	end #if exsist==false
 	
	tr = Geom::Transformation.new(p2, vector) if @kind=="pipe" or @kind=="pipe_bend" 
	#tr = @tr_temp_g * Geom::Transformation.new(p2, vector) if @kind=="pipe_auto" and vector #@tr_temp_g is "extra" transform becouse of temporaly group in Dezmo_pompi2016_auto.rb
	tr = Geom::Transformation.new(p2, vector) if @kind=="pipe_auto" and vector #@tr_temp_g is "extra" transform becouse of temporaly group in Dezmo_pompi2016_auto.rb

	#tr = @tr_temp_g*trans if @kind=="pipe_auto" and !vector
	tr = trans if @kind=="pipe_auto" and !vector
	
	this = Sketchup.active_model.active_entities.add_instance(@pipep,tr)
	$this_was_the_pipeline_csodarab_what_we_need_to_rotate_with_bend= this if @kind=="pipe_bend"

	Sketchup.active_model.select_tool Dezmo_pompi2016::Pompi_Rotate.new this, @kind if @kind=="pipe"

	end #self.pompi_pipe()



end #module Dezmo_pompi2016