#PomPi 2016 Copyright 2016, Dezmo
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end
#---------------------------------------------------------------------------- 

module Dezmo_pompi2016

# This part below is based on "Place_Component" & "Component on Face" by sdmitch (SDM Tools) 
#  Thanks!!
#  Get the component definition (pipe_to_place) and what kind (kind) from caller
	class Place_pompi_component

		def initialize(pipe_to_place, kind)
			@mod=Sketchup.active_model
			@ent=@mod.active_entities
			@sel=@mod.selection
			@ip=Sketchup::InputPoint.new
	
			@entered=0 #help bit if mouse entered to main window
			@edges_count=0 #conected edges to verex tuched by insertion (cursor)
			@ind_e=0 #index of conected edges to verex tuched by insertion (cursor)

			@cd = pipe_to_place #the "pipe" what was handled over
			@kind = kind # type of pipe (e.g.: bend, t_equal1, redu_conc...)

			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_b.png"), 0, 0) if @kind.include? "bend"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_te1.png"), 0, 0) if @kind.include? "t_equal1"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_te2.png"), 0, 0) if @kind.include? "t_equal2"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_ts1.png"), 0, 0) if @kind.include? "t_short1"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_ts2.png"), 0, 0) if @kind.include? "t_short2"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_re.png"), 0, 0) if @kind.include? "redu_exc"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_rc.png"), 0, 0) if @kind.include? "redu_conc"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_u.png"), 0, 0) if @kind.include? "union1"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_uf.png"), 0, 0) if @kind.include? "union2"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_f.png"), 0, 0) if @kind.include? "flange1"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_ff.png"), 0, 0) if @kind.include? "flange2"
			
			self.reset
		end
		
		def onSetCursor
			UI.set_cursor @cursor
		end#def	
		
		def reset
			@status_text = "Pick for Location. // Hit Escape/Right click to abort.// Click e.g. middle button to get focus, so arrow key rotation will work."
			@status = 0
			@bb = nil
			Sketchup::set_status_text @status_text,SB_PROMPT
			Sketchup::set_status_text("",SB_VCB_LABEL)
			Sketchup::set_status_text("",SB_VCB_VALUE)	
			if @cd
				@bb = @cd.bounds; @status = 1
			else
				onCancel(nil,nil)
			end
		end

		
#######################################################################		
#Trying a "Dirty" method to get focus from html window to SKETCHUP		
		def onMouseEnter(view)
			#@entered +=1
			#  puts "focus", view
			#This one seams to works, and just a little annoying...:-)
			#if @entered<2

			#	SKETCHUP_CONSOLE.hide
			#	SKETCHUP_CONSOLE.show
			#	SKETCHUP_CONSOLE.hide
			#end
		end
#Trying a "Dirty" method to get focus from html window to SKETCHUP
#######################################################################		
		
		
		def onMouseMove(flags, x, y, view)
			@ip.pick view,x,y
			view.tooltip = @ip.tooltip
			view.refresh #?? which one
			view.invalidate #?? which one
			Sketchup::set_status_text @status_text,SB_PROMPT
			Sketchup::set_status_text("",SB_VCB_LABEL)
			Sketchup::set_status_text("",SB_VCB_VALUE)	
			if @ip.face
				Sketchup::set_status_text "Face detected",SB_PROMPT 
				Sketchup::set_status_text("Face",SB_VCB_LABEL)
				Sketchup::set_status_text("",SB_VCB_VALUE)				
			end
			if @ip.edge
				Sketchup::set_status_text "Edge detected",SB_PROMPT
				Sketchup::set_status_text("Edge",SB_VCB_LABEL)
				Sketchup::set_status_text("",SB_VCB_VALUE)	
			end
			if @ip.vertex
				Sketchup::set_status_text "Vertex detected",SB_PROMPT 
				Sketchup::set_status_text "Multi-edge detected, use arrow keys to choose! // Click e.g. middle button to get focus, so arrow key rotation will work.",SB_PROMPT if  @edges_count>0
				Sketchup::set_status_text(@edges_count.to_s+" Edges. Selected:",SB_VCB_LABEL)
				Sketchup::set_status_text((@ind_e+1).to_s,SB_VCB_VALUE)		
			end
		end
		
		
		def onLButtonDown(flags, x, y, view)
		
			if @status==1
				this = @ent.add_instance(@cd,@tr)
			##### Bits to hand over the instance to Dezmo_pompi2016_rot.rb 
				Sketchup.active_model.select_tool Dezmo_pompi2016::Pompi_Rotate.new this, @kind 
			end
		end
		
		def onReturn(view)
			if @status==1
				this = @ent.add_instance(@cd,@tform)
			##### Bits to hand over the instance to Dezmo_pompi2016_rot.rb 
				Sketchup.active_model.select_tool Dezmo_pompi2016::Pompi_Rotate.new this, @kind 
			end		
		end
		
		
		
		def onRButtonDown(flags, x, y, view)
			@status==1 ? onCancel(flags,view) : self.reset
		end
		
		def onCancel(flags,view)
			#view.invalidate #refresh view
			Sketchup.active_model.active_view.refresh
			Sketchup.send_action "selectSelectionTool:"
		end

		def onKeyDown(key, repeat, flags, view)
			
			if @ip.vertex
			@ind_e=0 if !@ip.vertex.edges
				case key
				 when VK_LEFT then @ind_e +=-1 if @ind_e>0
				 when VK_DOWN then @ind_e +=-1  if @ind_e>0
				 when VK_RIGHT then @ind_e +=1 if @ind_e<@edges_count-1
				 when VK_UP then @ind_e +=1  if @ind_e<@edges_count-1
				 #
				end
			  view.invalidate #refresh view	

			Sketchup::set_status_text(@edges_count.to_s+" Edges. Selected:",SB_VCB_LABEL)
			Sketchup::set_status_text((@ind_e+1).to_s,SB_VCB_VALUE)		  
			end#if
			
		end	

		
		def draw(view)
			if( @ip.valid? && @ip.display? )
				@ip.draw(view)
			end
			
			@ind_e=0 if @edges_count==0
			@cpt = @ip.position
			@tform = @ip.transformation  
			if @ip.vertex
				@edges_count = @ip.vertex.edges.length
			#############################################################!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			# we need the original transformation of the point otherwise the vector is normal of original pipe position	
			# the position method on a input point always returns a point that is transformed into model space!!!!!!!!!!!!!			
				@nrm = @ip.vertex.edges[@ind_e].line[1] if @ip.vertex.edges[@ind_e] #vector of [@ind] edge of vertex touched by inputpoint (the index seleted by arrow buttons: onKeyDown above)
				@nrm.transform! @tform
				pt = view.screen_coords(@cpt)
				pt,vec = view.pickray(pt.x,pt.y)
				@nrm.reverse! if @nrm.angle_between(vec)<90.degrees
				xa,ya,za = @nrm.axes
				@tr = Geom::Transformation.axes(@cpt,xa,ya,za)
				self.draw_temporary(view)

			elsif @ip.edge
			#############################################################!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			# we need the original transformation of the point otherwise the vector is normal of original pipe position	
			# the position method on a input point always returns a point that is transformed into model space!!!!!!!!!!!!!			
				@nrm = @ip.edge.line[1]
				@nrm.transform! @tform
				pt = view.screen_coords(@cpt)
				pt,vec = view.pickray(pt.x,pt.y)
				@nrm.reverse! if @nrm.angle_between(vec)<90.degrees
				xa,ya,za = @nrm.axes
				@tr = Geom::Transformation.axes(@cpt,xa,ya,za)
				self.draw_temporary(view)
				
			elsif @ip.face
			#############################################################!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			# we need the original transformation of the point otherwise the vector is normal of original pipe position	
			# the position method on a input point always returns a point that is transformed into model space!!!!!!!!!!!!!			
				@nrm = @ip.face.normal
				@nrm.transform! @tform
				pt=view.screen_coords(@cpt)
				pt,vec = view.pickray(pt.x,pt.y)
				@nrm.reverse! if @nrm.angle_between(vec)<90.degrees
				xa,ya,za = @nrm.axes
				@tr = Geom::Transformation.axes(@cpt,xa,ya,za)
				self.draw_temporary(view)
				
			else
				@tr = Geom::Transformation.new(@ip.position)
				self.draw_temporary(view)

			end #if
			
		end #def draw(view)
		
		
		def draw_temporary(view)

				view.line_width = 2
				view.drawing_color = 'yellow'
				view.drawing_color = 'Pink' if @ip.face
				view.drawing_color = 'Coral' if @ip.edge
				view.drawing_color = 'green' if@ip.vertex
				
				pts = []
				(0..7).each{|i| pts << @bb.corner(i).transform(@tr)}
				view.draw GL_LINE_LOOP,pts[0],pts[1],pts[3],pts[2]
				view.draw GL_LINE_LOOP,pts[4],pts[5],pts[7],pts[6]
				(0..3).each{|i| view.draw_line pts[i],pts[i+4]}
				
				view.line_width = 4
				view.drawing_color = 'blue'
				pt0 = @cd.insertion_point.transform(@tr)
				pt1 = Geom::Point3d.linear_combination 0.5, pts[1], 0.5, pts[2] #bottom center
				pt2 = Geom::Point3d.linear_combination 0.5, pts[4], 0.5, pts[7] #top center
				pt3 = Geom::Point3d.linear_combination 0.5, pts[2], 0.5, pts[7] #back center (direction of pipe)
				pt4 = Geom::Point3d.linear_combination 0.5, pts[6], 0.5, pts[7] #top back center
				pt5 = Geom::Point3d.linear_combination 0.5, pts[4], 0.5, pts[5] #top front center
				pt6 = Geom::Point3d.linear_combination 0.5, pts[0], 0.5, pts[1] #bottom front center
				pt7 = Geom::Point3d.linear_combination 0.5, pts[0], 0.5, pts[5] #front center
				view.draw_line(pt0, pt2) if @kind=="bend"
				view.draw_line(pt2, pt4) if @kind=="bend"
				view.draw_line(pt1, pt2) if (@kind=="redu_conc" or @kind=="t_equal2" or @kind=="t_short2" or @kind.include? "flange" or @kind.include? "union")
				view.draw_line(pt0, pt5) if @kind=="redu_exc"
				view.draw_line(pt5, pt6) if (@kind=="t_equal1" or @kind=="t_short1")
				view.draw_line(pt3, pt7) if (@kind=="t_equal1" or @kind=="t_short1")
				view.draw_line(pt5, pt4) if (@kind=="t_equal2" or @kind=="t_short2")
				#view.draw_text(view.screen_coords(pts[7]), @kind)
				view.draw_points(pt0, 15, 1, "red")		
		
		end #def draw_temporary		
		
		
	end #class
# This part above is based on "Place_Component" by sdmitch (SDM Tools) 
#  Thanks!!	


end #module Dezmo_pompi2016